# ControlPlaneAPI
ControlPlaneAPI

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.3.1
- Package version: 1.3.1
- Generator version: 7.10.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.8+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import ControlPlaneAPI
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import ControlPlaneAPI
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import ControlPlaneAPI
from ControlPlaneAPI.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost/ControlPlaneAPI
# See configuration.py for a list of all supported configuration parameters.
configuration = ControlPlaneAPI.Configuration(
    host = "http://localhost/ControlPlaneAPI"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization (JWT): Bearer
configuration = ControlPlaneAPI.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with ControlPlaneAPI.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ControlPlaneAPI.OrchestrateApi(api_client)
    port = 56 # int | Active streaming port (optional)

    try:
        # Deletes WebRTC streamer
        api_response = api_instance.delete_delete_webrtc(port=port)
        print("The response of OrchestrateApi->delete_delete_webrtc:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling OrchestrateApi->delete_delete_webrtc: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost/ControlPlaneAPI*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*OrchestrateApi* | [**delete_delete_webrtc**](docs/OrchestrateApi.md#delete_delete_webrtc) | **DELETE** /delete | Deletes WebRTC streamer
*OrchestrateApi* | [**post_create_webrtc**](docs/OrchestrateApi.md#post_create_webrtc) | **POST** /create | Create WebRTC
*OrchestrateApi* | [**put_configure**](docs/OrchestrateApi.md#put_configure) | **PUT** /configure | Configures setup


## Documentation For Models

 - [Dummy](docs/Dummy.md)
 - [RequestBody](docs/RequestBody.md)
 - [RequestBodyComponentsInner](docs/RequestBodyComponentsInner.md)
 - [RequestBodyComponentsInnerIoHandles](docs/RequestBodyComponentsInnerIoHandles.md)
 - [RequestBodyComponentsInnerIoHandlesInputInner](docs/RequestBodyComponentsInnerIoHandlesInputInner.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="Bearer"></a>
### Bearer

- **Type**: Bearer authentication (JWT)


## Author

luke.brown@3adesign.co.uk


